/******************************************************************************
devlist.c

  Developed November 1991 by Larry Reeve

A TurboC program to display a list of all device drivers in memory.
Both character and block devices are listed.
******************************************************************************/
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>

#define  BYTE               unsigned char
#define  WORD               unsigned int

#define  IS_CHAR_DEVICE     0x8000


struct  DDH_struct
{
    struct DDH_struct       far *next_DDH;
    WORD                    ddh_attribute;
    WORD                    ddh_strategy;
    WORD                    ddh_interrupt;
    BYTE                    ddh_name[8];
};

struct  DOS_struct
{
    BYTE                    reserved[34];
    struct DDH_struct       far *ddh_ptr;
};

void main (void)
{
    int                 i;
    WORD                es_reg;
    WORD                bx_reg;
    BYTE                last_drive;
    struct DOS_struct   far *dos_ptr;
    struct DDH_struct   far *ddh_ptr;
    struct DDH_struct   far *ddh_walk;
    char                device_type[16];

    printf("DEVLIST 1.0 - List Currently Loaded Device Drivers");
    printf("\n");
    printf("\n     Device Driver     Type");
    printf("\n     ");

    _AX = 0x5200;
    geninterrupt(0x21);
    bx_reg = _BX;
    es_reg = _ES;

    dos_ptr = MK_FP(es_reg,bx_reg);
    ddh_ptr = (struct DDH_struct far *) &dos_ptr->ddh_ptr;

    last_drive = 0;
    while (FP_OFF(ddh_ptr) != 0xFFFF)
    {
        printf("\n     ");

        if (ddh_ptr->ddh_attribute & IS_CHAR_DEVICE)
          {
          strcpy(device_type,"Character");
          for (i=0; i < 8; i++)
            putchar(ddh_ptr->ddh_name[i]);
          }

        else
          {
          strcpy(device_type,"Block");
          printf("%c: -> %c:",last_drive+65,last_drive+(ddh_ptr->ddh_name[0]-1)+65);
          last_drive = last_drive + ddh_ptr->ddh_name[0] + 1;
          }

        printf("          ");
        printf("%s",device_type);

        ddh_ptr = ddh_ptr->next_DDH;
    }
    printf("\n\n");
}
